'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var jestWG = jest;
var expectWG = expect; // Jest's list of globals: https://jestjs.io/docs/en/api

var afterAllWG = afterAll;
var afterEachWG = afterEach;
var beforeAllWG = beforeAll;
var beforeEachWG = beforeEach;
var describeWG = describe;
var fdescribeWG = fdescribe; // alias for describe.only

var xdescribeWG = xdescribe; // alias for describe.skip

var testWG = test;
var itWG = it; // alias for test

var fitWG = fit; // alias for it.only

var xtestWG = xtest; // alias for test.skip

var xitWG = xit; // alias for it.skip

/** PURE_IMPORTS_START  PURE_IMPORTS_END */
function isFunction(x) {
    return typeof x === 'function';
}

/** PURE_IMPORTS_START  PURE_IMPORTS_END */
var _enable_super_gross_mode_that_will_cause_bad_things = false;
var config = {
    Promise: undefined,
    set useDeprecatedSynchronousErrorHandling(value) {
        if (value) {
            var error = /*@__PURE__*/ new Error();
            /*@__PURE__*/ console.warn('DEPRECATED! RxJS was set to use deprecated synchronous error handling behavior by code at: \n' + error.stack);
        }
        _enable_super_gross_mode_that_will_cause_bad_things = value;
    },
    get useDeprecatedSynchronousErrorHandling() {
        return _enable_super_gross_mode_that_will_cause_bad_things;
    },
};

/** PURE_IMPORTS_START  PURE_IMPORTS_END */
function hostReportError(err) {
    setTimeout(function () { throw err; }, 0);
}

/** PURE_IMPORTS_START _config,_util_hostReportError PURE_IMPORTS_END */
var empty = {
    closed: true,
    next: function (value) { },
    error: function (err) {
        if (config.useDeprecatedSynchronousErrorHandling) {
            throw err;
        }
        else {
            hostReportError(err);
        }
    },
    complete: function () { }
};

/** PURE_IMPORTS_START  PURE_IMPORTS_END */
var isArray = /*@__PURE__*/ (function () { return Array.isArray || (function (x) { return x && typeof x.length === 'number'; }); })();

/** PURE_IMPORTS_START  PURE_IMPORTS_END */
function isObject(x) {
    return x !== null && typeof x === 'object';
}

/** PURE_IMPORTS_START  PURE_IMPORTS_END */
var UnsubscriptionErrorImpl = /*@__PURE__*/ (function () {
    function UnsubscriptionErrorImpl(errors) {
        Error.call(this);
        this.message = errors ?
            errors.length + " errors occurred during unsubscription:\n" + errors.map(function (err, i) { return i + 1 + ") " + err.toString(); }).join('\n  ') : '';
        this.name = 'UnsubscriptionError';
        this.errors = errors;
        return this;
    }
    UnsubscriptionErrorImpl.prototype = /*@__PURE__*/ Object.create(Error.prototype);
    return UnsubscriptionErrorImpl;
})();
var UnsubscriptionError = UnsubscriptionErrorImpl;

/** PURE_IMPORTS_START _util_isArray,_util_isObject,_util_isFunction,_util_UnsubscriptionError PURE_IMPORTS_END */
var Subscription = /*@__PURE__*/ (function () {
    function Subscription(unsubscribe) {
        this.closed = false;
        this._parentOrParents = null;
        this._subscriptions = null;
        if (unsubscribe) {
            this._unsubscribe = unsubscribe;
        }
    }
    Subscription.prototype.unsubscribe = function () {
        var errors;
        if (this.closed) {
            return;
        }
        var _a = this, _parentOrParents = _a._parentOrParents, _unsubscribe = _a._unsubscribe, _subscriptions = _a._subscriptions;
        this.closed = true;
        this._parentOrParents = null;
        this._subscriptions = null;
        if (_parentOrParents instanceof Subscription) {
            _parentOrParents.remove(this);
        }
        else if (_parentOrParents !== null) {
            for (var index = 0; index < _parentOrParents.length; ++index) {
                var parent_1 = _parentOrParents[index];
                parent_1.remove(this);
            }
        }
        if (isFunction(_unsubscribe)) {
            try {
                _unsubscribe.call(this);
            }
            catch (e) {
                errors = e instanceof UnsubscriptionError ? flattenUnsubscriptionErrors(e.errors) : [e];
            }
        }
        if (isArray(_subscriptions)) {
            var index = -1;
            var len = _subscriptions.length;
            while (++index < len) {
                var sub = _subscriptions[index];
                if (isObject(sub)) {
                    try {
                        sub.unsubscribe();
                    }
                    catch (e) {
                        errors = errors || [];
                        if (e instanceof UnsubscriptionError) {
                            errors = errors.concat(flattenUnsubscriptionErrors(e.errors));
                        }
                        else {
                            errors.push(e);
                        }
                    }
                }
            }
        }
        if (errors) {
            throw new UnsubscriptionError(errors);
        }
    };
    Subscription.prototype.add = function (teardown) {
        var subscription = teardown;
        if (!teardown) {
            return Subscription.EMPTY;
        }
        switch (typeof teardown) {
            case 'function':
                subscription = new Subscription(teardown);
            case 'object':
                if (subscription === this || subscription.closed || typeof subscription.unsubscribe !== 'function') {
                    return subscription;
                }
                else if (this.closed) {
                    subscription.unsubscribe();
                    return subscription;
                }
                else if (!(subscription instanceof Subscription)) {
                    var tmp = subscription;
                    subscription = new Subscription();
                    subscription._subscriptions = [tmp];
                }
                break;
            default: {
                throw new Error('unrecognized teardown ' + teardown + ' added to Subscription.');
            }
        }
        var _parentOrParents = subscription._parentOrParents;
        if (_parentOrParents === null) {
            subscription._parentOrParents = this;
        }
        else if (_parentOrParents instanceof Subscription) {
            if (_parentOrParents === this) {
                return subscription;
            }
            subscription._parentOrParents = [_parentOrParents, this];
        }
        else if (_parentOrParents.indexOf(this) === -1) {
            _parentOrParents.push(this);
        }
        else {
            return subscription;
        }
        var subscriptions = this._subscriptions;
        if (subscriptions === null) {
            this._subscriptions = [subscription];
        }
        else {
            subscriptions.push(subscription);
        }
        return subscription;
    };
    Subscription.prototype.remove = function (subscription) {
        var subscriptions = this._subscriptions;
        if (subscriptions) {
            var subscriptionIndex = subscriptions.indexOf(subscription);
            if (subscriptionIndex !== -1) {
                subscriptions.splice(subscriptionIndex, 1);
            }
        }
    };
    Subscription.EMPTY = (function (empty) {
        empty.closed = true;
        return empty;
    }(new Subscription()));
    return Subscription;
}());
function flattenUnsubscriptionErrors(errors) {
    return errors.reduce(function (errs, err) { return errs.concat((err instanceof UnsubscriptionError) ? err.errors : err); }, []);
}

/** PURE_IMPORTS_START  PURE_IMPORTS_END */
var rxSubscriber = /*@__PURE__*/ (function () {
    return typeof Symbol === 'function'
        ? /*@__PURE__*/ Symbol('rxSubscriber')
        : '@@rxSubscriber_' + /*@__PURE__*/ Math.random();
})();

/** PURE_IMPORTS_START tslib,_util_isFunction,_Observer,_Subscription,_internal_symbol_rxSubscriber,_config,_util_hostReportError PURE_IMPORTS_END */
var Subscriber = /*@__PURE__*/ (function (_super) {
    __extends(Subscriber, _super);
    function Subscriber(destinationOrNext, error, complete) {
        var _this = _super.call(this) || this;
        _this.syncErrorValue = null;
        _this.syncErrorThrown = false;
        _this.syncErrorThrowable = false;
        _this.isStopped = false;
        switch (arguments.length) {
            case 0:
                _this.destination = empty;
                break;
            case 1:
                if (!destinationOrNext) {
                    _this.destination = empty;
                    break;
                }
                if (typeof destinationOrNext === 'object') {
                    if (destinationOrNext instanceof Subscriber) {
                        _this.syncErrorThrowable = destinationOrNext.syncErrorThrowable;
                        _this.destination = destinationOrNext;
                        destinationOrNext.add(_this);
                    }
                    else {
                        _this.syncErrorThrowable = true;
                        _this.destination = new SafeSubscriber(_this, destinationOrNext);
                    }
                    break;
                }
            default:
                _this.syncErrorThrowable = true;
                _this.destination = new SafeSubscriber(_this, destinationOrNext, error, complete);
                break;
        }
        return _this;
    }
    Subscriber.prototype[rxSubscriber] = function () { return this; };
    Subscriber.create = function (next, error, complete) {
        var subscriber = new Subscriber(next, error, complete);
        subscriber.syncErrorThrowable = false;
        return subscriber;
    };
    Subscriber.prototype.next = function (value) {
        if (!this.isStopped) {
            this._next(value);
        }
    };
    Subscriber.prototype.error = function (err) {
        if (!this.isStopped) {
            this.isStopped = true;
            this._error(err);
        }
    };
    Subscriber.prototype.complete = function () {
        if (!this.isStopped) {
            this.isStopped = true;
            this._complete();
        }
    };
    Subscriber.prototype.unsubscribe = function () {
        if (this.closed) {
            return;
        }
        this.isStopped = true;
        _super.prototype.unsubscribe.call(this);
    };
    Subscriber.prototype._next = function (value) {
        this.destination.next(value);
    };
    Subscriber.prototype._error = function (err) {
        this.destination.error(err);
        this.unsubscribe();
    };
    Subscriber.prototype._complete = function () {
        this.destination.complete();
        this.unsubscribe();
    };
    Subscriber.prototype._unsubscribeAndRecycle = function () {
        var _parentOrParents = this._parentOrParents;
        this._parentOrParents = null;
        this.unsubscribe();
        this.closed = false;
        this.isStopped = false;
        this._parentOrParents = _parentOrParents;
        return this;
    };
    return Subscriber;
}(Subscription));
var SafeSubscriber = /*@__PURE__*/ (function (_super) {
    __extends(SafeSubscriber, _super);
    function SafeSubscriber(_parentSubscriber, observerOrNext, error, complete) {
        var _this = _super.call(this) || this;
        _this._parentSubscriber = _parentSubscriber;
        var next;
        var context = _this;
        if (isFunction(observerOrNext)) {
            next = observerOrNext;
        }
        else if (observerOrNext) {
            next = observerOrNext.next;
            error = observerOrNext.error;
            complete = observerOrNext.complete;
            if (observerOrNext !== empty) {
                context = Object.create(observerOrNext);
                if (isFunction(context.unsubscribe)) {
                    _this.add(context.unsubscribe.bind(context));
                }
                context.unsubscribe = _this.unsubscribe.bind(_this);
            }
        }
        _this._context = context;
        _this._next = next;
        _this._error = error;
        _this._complete = complete;
        return _this;
    }
    SafeSubscriber.prototype.next = function (value) {
        if (!this.isStopped && this._next) {
            var _parentSubscriber = this._parentSubscriber;
            if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                this.__tryOrUnsub(this._next, value);
            }
            else if (this.__tryOrSetError(_parentSubscriber, this._next, value)) {
                this.unsubscribe();
            }
        }
    };
    SafeSubscriber.prototype.error = function (err) {
        if (!this.isStopped) {
            var _parentSubscriber = this._parentSubscriber;
            var useDeprecatedSynchronousErrorHandling = config.useDeprecatedSynchronousErrorHandling;
            if (this._error) {
                if (!useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                    this.__tryOrUnsub(this._error, err);
                    this.unsubscribe();
                }
                else {
                    this.__tryOrSetError(_parentSubscriber, this._error, err);
                    this.unsubscribe();
                }
            }
            else if (!_parentSubscriber.syncErrorThrowable) {
                this.unsubscribe();
                if (useDeprecatedSynchronousErrorHandling) {
                    throw err;
                }
                hostReportError(err);
            }
            else {
                if (useDeprecatedSynchronousErrorHandling) {
                    _parentSubscriber.syncErrorValue = err;
                    _parentSubscriber.syncErrorThrown = true;
                }
                else {
                    hostReportError(err);
                }
                this.unsubscribe();
            }
        }
    };
    SafeSubscriber.prototype.complete = function () {
        var _this = this;
        if (!this.isStopped) {
            var _parentSubscriber = this._parentSubscriber;
            if (this._complete) {
                var wrappedComplete = function () { return _this._complete.call(_this._context); };
                if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                    this.__tryOrUnsub(wrappedComplete);
                    this.unsubscribe();
                }
                else {
                    this.__tryOrSetError(_parentSubscriber, wrappedComplete);
                    this.unsubscribe();
                }
            }
            else {
                this.unsubscribe();
            }
        }
    };
    SafeSubscriber.prototype.__tryOrUnsub = function (fn, value) {
        try {
            fn.call(this._context, value);
        }
        catch (err) {
            this.unsubscribe();
            if (config.useDeprecatedSynchronousErrorHandling) {
                throw err;
            }
            else {
                hostReportError(err);
            }
        }
    };
    SafeSubscriber.prototype.__tryOrSetError = function (parent, fn, value) {
        if (!config.useDeprecatedSynchronousErrorHandling) {
            throw new Error('bad call');
        }
        try {
            fn.call(this._context, value);
        }
        catch (err) {
            if (config.useDeprecatedSynchronousErrorHandling) {
                parent.syncErrorValue = err;
                parent.syncErrorThrown = true;
                return true;
            }
            else {
                hostReportError(err);
                return true;
            }
        }
        return false;
    };
    SafeSubscriber.prototype._unsubscribe = function () {
        var _parentSubscriber = this._parentSubscriber;
        this._context = null;
        this._parentSubscriber = null;
        _parentSubscriber.unsubscribe();
    };
    return SafeSubscriber;
}(Subscriber));

/** PURE_IMPORTS_START _Subscriber PURE_IMPORTS_END */
function canReportError(observer) {
    while (observer) {
        var _a = observer, closed_1 = _a.closed, destination = _a.destination, isStopped = _a.isStopped;
        if (closed_1 || isStopped) {
            return false;
        }
        else if (destination && destination instanceof Subscriber) {
            observer = destination;
        }
        else {
            observer = null;
        }
    }
    return true;
}

/** PURE_IMPORTS_START _Subscriber,_symbol_rxSubscriber,_Observer PURE_IMPORTS_END */
function toSubscriber(nextOrObserver, error, complete) {
    if (nextOrObserver) {
        if (nextOrObserver instanceof Subscriber) {
            return nextOrObserver;
        }
        if (nextOrObserver[rxSubscriber]) {
            return nextOrObserver[rxSubscriber]();
        }
    }
    if (!nextOrObserver && !error && !complete) {
        return new Subscriber(empty);
    }
    return new Subscriber(nextOrObserver, error, complete);
}

/** PURE_IMPORTS_START  PURE_IMPORTS_END */
var observable = /*@__PURE__*/ (function () { return typeof Symbol === 'function' && Symbol.observable || '@@observable'; })();

/** PURE_IMPORTS_START  PURE_IMPORTS_END */
function noop() { }

/** PURE_IMPORTS_START _noop PURE_IMPORTS_END */
function pipeFromArray(fns) {
    if (!fns) {
        return noop;
    }
    if (fns.length === 1) {
        return fns[0];
    }
    return function piped(input) {
        return fns.reduce(function (prev, fn) { return fn(prev); }, input);
    };
}

/** PURE_IMPORTS_START _util_canReportError,_util_toSubscriber,_symbol_observable,_util_pipe,_config PURE_IMPORTS_END */
var Observable = /*@__PURE__*/ (function () {
    function Observable(subscribe) {
        this._isScalar = false;
        if (subscribe) {
            this._subscribe = subscribe;
        }
    }
    Observable.prototype.lift = function (operator) {
        var observable = new Observable();
        observable.source = this;
        observable.operator = operator;
        return observable;
    };
    Observable.prototype.subscribe = function (observerOrNext, error, complete) {
        var operator = this.operator;
        var sink = toSubscriber(observerOrNext, error, complete);
        if (operator) {
            sink.add(operator.call(sink, this.source));
        }
        else {
            sink.add(this.source || (config.useDeprecatedSynchronousErrorHandling && !sink.syncErrorThrowable) ?
                this._subscribe(sink) :
                this._trySubscribe(sink));
        }
        if (config.useDeprecatedSynchronousErrorHandling) {
            if (sink.syncErrorThrowable) {
                sink.syncErrorThrowable = false;
                if (sink.syncErrorThrown) {
                    throw sink.syncErrorValue;
                }
            }
        }
        return sink;
    };
    Observable.prototype._trySubscribe = function (sink) {
        try {
            return this._subscribe(sink);
        }
        catch (err) {
            if (config.useDeprecatedSynchronousErrorHandling) {
                sink.syncErrorThrown = true;
                sink.syncErrorValue = err;
            }
            if (canReportError(sink)) {
                sink.error(err);
            }
            else {
                console.warn(err);
            }
        }
    };
    Observable.prototype.forEach = function (next, promiseCtor) {
        var _this = this;
        promiseCtor = getPromiseCtor(promiseCtor);
        return new promiseCtor(function (resolve, reject) {
            var subscription;
            subscription = _this.subscribe(function (value) {
                try {
                    next(value);
                }
                catch (err) {
                    reject(err);
                    if (subscription) {
                        subscription.unsubscribe();
                    }
                }
            }, reject, resolve);
        });
    };
    Observable.prototype._subscribe = function (subscriber) {
        var source = this.source;
        return source && source.subscribe(subscriber);
    };
    Observable.prototype[observable] = function () {
        return this;
    };
    Observable.prototype.pipe = function () {
        var operations = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operations[_i] = arguments[_i];
        }
        if (operations.length === 0) {
            return this;
        }
        return pipeFromArray(operations)(this);
    };
    Observable.prototype.toPromise = function (promiseCtor) {
        var _this = this;
        promiseCtor = getPromiseCtor(promiseCtor);
        return new promiseCtor(function (resolve, reject) {
            var value;
            _this.subscribe(function (x) { return value = x; }, function (err) { return reject(err); }, function () { return resolve(value); });
        });
    };
    Observable.create = function (subscribe) {
        return new Observable(subscribe);
    };
    return Observable;
}());
function getPromiseCtor(promiseCtor) {
    if (!promiseCtor) {
        promiseCtor =  Promise;
    }
    if (!promiseCtor) {
        throw new Error('no Promise impl found');
    }
    return promiseCtor;
}

/** PURE_IMPORTS_START  PURE_IMPORTS_END */
var ObjectUnsubscribedErrorImpl = /*@__PURE__*/ (function () {
    function ObjectUnsubscribedErrorImpl() {
        Error.call(this);
        this.message = 'object unsubscribed';
        this.name = 'ObjectUnsubscribedError';
        return this;
    }
    ObjectUnsubscribedErrorImpl.prototype = /*@__PURE__*/ Object.create(Error.prototype);
    return ObjectUnsubscribedErrorImpl;
})();
var ObjectUnsubscribedError = ObjectUnsubscribedErrorImpl;

/** PURE_IMPORTS_START tslib,_Subscription PURE_IMPORTS_END */
var SubjectSubscription = /*@__PURE__*/ (function (_super) {
    __extends(SubjectSubscription, _super);
    function SubjectSubscription(subject, subscriber) {
        var _this = _super.call(this) || this;
        _this.subject = subject;
        _this.subscriber = subscriber;
        _this.closed = false;
        return _this;
    }
    SubjectSubscription.prototype.unsubscribe = function () {
        if (this.closed) {
            return;
        }
        this.closed = true;
        var subject = this.subject;
        var observers = subject.observers;
        this.subject = null;
        if (!observers || observers.length === 0 || subject.isStopped || subject.closed) {
            return;
        }
        var subscriberIndex = observers.indexOf(this.subscriber);
        if (subscriberIndex !== -1) {
            observers.splice(subscriberIndex, 1);
        }
    };
    return SubjectSubscription;
}(Subscription));

/** PURE_IMPORTS_START tslib,_Observable,_Subscriber,_Subscription,_util_ObjectUnsubscribedError,_SubjectSubscription,_internal_symbol_rxSubscriber PURE_IMPORTS_END */
var SubjectSubscriber = /*@__PURE__*/ (function (_super) {
    __extends(SubjectSubscriber, _super);
    function SubjectSubscriber(destination) {
        var _this = _super.call(this, destination) || this;
        _this.destination = destination;
        return _this;
    }
    return SubjectSubscriber;
}(Subscriber));
var Subject = /*@__PURE__*/ (function (_super) {
    __extends(Subject, _super);
    function Subject() {
        var _this = _super.call(this) || this;
        _this.observers = [];
        _this.closed = false;
        _this.isStopped = false;
        _this.hasError = false;
        _this.thrownError = null;
        return _this;
    }
    Subject.prototype[rxSubscriber] = function () {
        return new SubjectSubscriber(this);
    };
    Subject.prototype.lift = function (operator) {
        var subject = new AnonymousSubject(this, this);
        subject.operator = operator;
        return subject;
    };
    Subject.prototype.next = function (value) {
        if (this.closed) {
            throw new ObjectUnsubscribedError();
        }
        if (!this.isStopped) {
            var observers = this.observers;
            var len = observers.length;
            var copy = observers.slice();
            for (var i = 0; i < len; i++) {
                copy[i].next(value);
            }
        }
    };
    Subject.prototype.error = function (err) {
        if (this.closed) {
            throw new ObjectUnsubscribedError();
        }
        this.hasError = true;
        this.thrownError = err;
        this.isStopped = true;
        var observers = this.observers;
        var len = observers.length;
        var copy = observers.slice();
        for (var i = 0; i < len; i++) {
            copy[i].error(err);
        }
        this.observers.length = 0;
    };
    Subject.prototype.complete = function () {
        if (this.closed) {
            throw new ObjectUnsubscribedError();
        }
        this.isStopped = true;
        var observers = this.observers;
        var len = observers.length;
        var copy = observers.slice();
        for (var i = 0; i < len; i++) {
            copy[i].complete();
        }
        this.observers.length = 0;
    };
    Subject.prototype.unsubscribe = function () {
        this.isStopped = true;
        this.closed = true;
        this.observers = null;
    };
    Subject.prototype._trySubscribe = function (subscriber) {
        if (this.closed) {
            throw new ObjectUnsubscribedError();
        }
        else {
            return _super.prototype._trySubscribe.call(this, subscriber);
        }
    };
    Subject.prototype._subscribe = function (subscriber) {
        if (this.closed) {
            throw new ObjectUnsubscribedError();
        }
        else if (this.hasError) {
            subscriber.error(this.thrownError);
            return Subscription.EMPTY;
        }
        else if (this.isStopped) {
            subscriber.complete();
            return Subscription.EMPTY;
        }
        else {
            this.observers.push(subscriber);
            return new SubjectSubscription(this, subscriber);
        }
    };
    Subject.prototype.asObservable = function () {
        var observable = new Observable();
        observable.source = this;
        return observable;
    };
    Subject.create = function (destination, source) {
        return new AnonymousSubject(destination, source);
    };
    return Subject;
}(Observable));
var AnonymousSubject = /*@__PURE__*/ (function (_super) {
    __extends(AnonymousSubject, _super);
    function AnonymousSubject(destination, source) {
        var _this = _super.call(this) || this;
        _this.destination = destination;
        _this.source = source;
        return _this;
    }
    AnonymousSubject.prototype.next = function (value) {
        var destination = this.destination;
        if (destination && destination.next) {
            destination.next(value);
        }
    };
    AnonymousSubject.prototype.error = function (err) {
        var destination = this.destination;
        if (destination && destination.error) {
            this.destination.error(err);
        }
    };
    AnonymousSubject.prototype.complete = function () {
        var destination = this.destination;
        if (destination && destination.complete) {
            this.destination.complete();
        }
    };
    AnonymousSubject.prototype._subscribe = function (subscriber) {
        var source = this.source;
        if (source) {
            return this.source.subscribe(subscriber);
        }
        else {
            return Subscription.EMPTY;
        }
    };
    return AnonymousSubject;
}(Subject));

var PeerjsConnection = /** @class */ (function () {
    function PeerjsConnection(connection) {
        var _this = this;
        this.connection = connection;
        this.messages = new Subject();
        this.connection.on('data', function (message) {
            _this.receiveMessage(message);
        });
    }
    PeerjsConnection.prototype.send = function (message) {
        var _this = this;
        // The testdelay URL flag can be used to test bad network conditions.
        if (location.href.includes('testdelay')) {
            setTimeout(function () { return _this.connection.send(message); }, Math.round(Math.random() * 100));
        }
        else {
            this.connection.send(message);
        }
    };
    PeerjsConnection.prototype.getPeer = function () {
        return this.connection.peer;
    };
    PeerjsConnection.prototype.receiveMessage = function (message) {
        this.messages.next(message);
    };
    PeerjsConnection.prototype.open = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this.connection.on('open', resolve);
        });
    };
    return PeerjsConnection;
}());

var PeerjsNetwork = /** @class */ (function () {
    function PeerjsNetwork() {
        this.onOpen = function () { return 0; };
    }
    PeerjsNetwork.prototype.init = function (id, onOpen, onConnection, onDisconnection) {
        this.onOpen = onOpen;
        this.peer = new Peer(id, {
            host: 'michaschwab.de',
            port: 9000,
            secure: true,
            path: '/visconnect',
            config: { 'iceServers': [
                    { urls: 'stun:stun.l.google.com:19302' },
                    {
                        'urls': 'turn:numb.viagenie.ca',
                        'credential': "a/j'/9CmxTCa",
                        'username': 'saffo.d@husky.neu.edu'
                    }
                ] }
        });
        console.log(this.peer.id);
        console.log(this.peer);
        if (this.peer.id) {
            this.onOpen(); // In case it was done too fast.
        }
        else {
            this.peer.on('open', this.onOpen);
        }
        this.peer.on('connection', function (connection) {
            console.log("connection!");
            onConnection(new PeerjsConnection(connection));
        });
        this.peer.on('disconnected', function () {
            onDisconnection();
        });
        window.addEventListener("beforeunload", function () { return onDisconnection(); });
    };
    PeerjsNetwork.prototype.getId = function () {
        return this.peer.id;
    };
    PeerjsNetwork.prototype.connect = function (peerId) {
        var _this = this;
        return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
            var conn, connection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        conn = this.peer.connect(peerId);
                        connection = new PeerjsConnection(conn);
                        return [4 /*yield*/, connection.open()];
                    case 1:
                        _a.sent();
                        resolve(connection);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    return PeerjsNetwork;
}());

var VcCommunication = /** @class */ (function () {
    function VcCommunication(data) {
        this.connections = [];
        this.peers = [];
        this.onConnectionCallback = function () { };
        this.id = '';
        this.lastEventsMessageTime = -1;
        this.throttleTimeout = -1;
        this.leaderId = data.leaderId;
        this.id = data.ownId;
        this.onEventReceived = data.onEventReceived;
        this.onNewLockOwner = data.onNewLockOwner;
        this.getPastEvents = data.getPastEvents;
        this.onLockRequested = data.onLockRequested;
        this.onOpenCallback = data.onOpenCallback;
        this.peer = new PeerjsNetwork();
    }
    VcCommunication.prototype.init = function () {
        console.log('communication init with own id ', this.id);
        this.peer.init(this.id, this.onOpen.bind(this), this.onConnection.bind(this), this.onDisconnection.bind(this));
    };
    /**
     * Requests all clients to vote to agree that this client gets the lock on the element.
     */
    VcCommunication.prototype.requestLock = function (targetSelector) {
        if (!this.id) {
            return false;
        }
        if (!this.leaderConnection && this.id !== this.leaderId) {
            return false;
        }
        var msg = {
            type: VC_MESSAGE_TYPE.LOCK_REQUESTED,
            targetSelector: targetSelector,
            requester: this.id,
            sender: this.id,
        };
        if (this.id === this.leaderId) {
            // Ask itself, the leader, for permission.
            this.receiveMessage(msg);
        }
        else {
            // Ask the leader for permission.
            this.leaderConnection.send(msg);
        }
        return true;
    };
    /**
     * This message is sent by the leader to inform clients that an element's lock owner has changed.
     */
    VcCommunication.prototype.changeLockOwner = function (targetSelector, owner, seqNum) {
        var msg = {
            type: VC_MESSAGE_TYPE.LOCK_OWNER_CHANGED,
            targetSelector: targetSelector,
            owner: owner,
            sender: this.id,
            seqNum: seqNum
        };
        for (var _i = 0, _a = this.connections; _i < _a.length; _i++) {
            var conn = _a[_i];
            conn.send(msg);
        }
        this.receiveMessage(msg); // Tell itself that the lock owner has changed.
    };
    VcCommunication.prototype.getId = function () {
        return this.peer.getId();
    };
    VcCommunication.prototype.onOpen = function () {
        this.id = this.getId();
        if (!this.leaderId) {
            this.leaderId = this.id;
        }
        //console.log("originID", this.leaderId);
        //console.log("myID", this.id);
        this.connectToPeer(this.id);
        if (this.leaderId && this.leaderId !== this.id) {
            this.connectToPeer(this.leaderId);
        }
        this.onOpenCallback();
        this.onConnectionCallback();
    };
    VcCommunication.prototype.getNumberOfConnections = function () {
        return this.connections.length;
    };
    VcCommunication.prototype.onConnection = function (connection) {
        return __awaiter(this, void 0, void 0, function () {
            var peer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        peer = connection.getPeer();
                        this.peers.push(peer);
                        this.connections.push(connection);
                        //console.log("New incoming connection", this.peers, this.connections.length);
                        this.onConnectionCallback();
                        if (peer === this.leaderId) {
                            // This is in case this client is the leader.
                            this.leaderConnection = connection;
                        }
                        return [4 /*yield*/, connection.open()];
                    case 1:
                        _a.sent();
                        connection.messages.subscribe(this.receiveMessage.bind(this));
                        if (this.leaderId === this.id) {
                            this.sendNewConnection(connection);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    VcCommunication.prototype.onDisconnection = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.sendDisconnectMessage();
                return [2 /*return*/];
            });
        });
    };
    VcCommunication.prototype.connectToPeer = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, peer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.peer.connect(id)];
                    case 1:
                        connection = _a.sent();
                        this.connections.push(connection);
                        this.peers.push(id);
                        //console.log("New outgoing connection", this.peers, this.connections.length);
                        this.onConnectionCallback();
                        peer = connection.getPeer();
                        if (peer === this.leaderId) {
                            this.leaderConnection = connection;
                        }
                        connection.messages.subscribe(this.receiveMessage.bind(this));
                        return [2 /*return*/];
                }
            });
        });
    };
    VcCommunication.prototype.receiveMessage = function (data) {
        if (data.type === VC_MESSAGE_TYPE.NEW_CONNECTION) {
            this.receiveNewConnection(data);
        }
        else if (data.type === VC_MESSAGE_TYPE.EVENT) {
            var msg = data;
            this.onEventReceived(msg.data, msg.sender);
        }
        else if (data.type === VC_MESSAGE_TYPE.LOCK_REQUESTED) {
            var msg = data;
            this.onLockRequested(msg.targetSelector, msg.requester);
        }
        else if (data.type === VC_MESSAGE_TYPE.LOCK_OWNER_CHANGED) {
            var msg = data;
            this.onNewLockOwner(msg.targetSelector, msg.owner, msg.seqNum);
        }
        else if (data.type === VC_MESSAGE_TYPE.DISCONNECTION) {
            var msg = data;
            this.recieveDisconnectMessage(msg);
        }
    };
    VcCommunication.prototype.broadcastEvent = function (e) {
        if (!this.eventsMsg) {
            this.eventsMsg = {
                'type': VC_MESSAGE_TYPE.EVENT,
                'sender': this.id,
                data: [],
            };
        }
        this.eventsMsg.data.push(e);
        this.throttledSendEvents();
    };
    VcCommunication.prototype.throttledSendEvents = function () {
        var _this = this;
        if (!this.eventsMsg) {
            return;
        }
        var onSend = function () {
            if (!_this.eventsMsg) {
                return;
            }
            for (var _i = 0, _a = _this.connections; _i < _a.length; _i++) {
                var conn = _a[_i];
                conn.send(_this.eventsMsg);
            }
            _this.lastEventsMessageTime = Date.now();
            _this.eventsMsg = undefined;
            _this.throttleTimeout = -1;
        };
        window.requestAnimationFrame(onSend);
    };
    VcCommunication.prototype.sendNewConnection = function (conn) {
        //console.log("Sending new connection message");
        var decoratedMessage = {
            'type': VC_MESSAGE_TYPE.NEW_CONNECTION,
            'sender': this.id,
            'peers': this.peers,
            'eventsLedger': this.getPastEvents(),
        };
        conn.send(decoratedMessage);
    };
    VcCommunication.prototype.receiveNewConnection = function (data) {
        //console.log("New connection message", data);
        for (var i = 0; i < data.peers.length; i++) {
            if (this.peers.indexOf(data.peers[i]) === -1) {
                console.log("connecting to new peer", data.peers[i]);
                this.connectToPeer(data.peers[i]);
            }
        }
        this.onEventReceived(data.eventsLedger, data.sender, true);
    };
    VcCommunication.prototype.sendDisconnectMessage = function () {
        var decoratedMessage = {
            'type': VC_MESSAGE_TYPE.DISCONNECTION,
            'sender': this.id
        };
        for (var _i = 0, _a = this.connections; _i < _a.length; _i++) {
            var conn = _a[_i];
            conn.send(decoratedMessage);
        }
    };
    VcCommunication.prototype.recieveDisconnectMessage = function (msg) {
        console.log("Peer", msg.sender, "is disconnecting");
        for (var _i = 0, _a = this.connections; _i < _a.length; _i++) {
            var conn = _a[_i];
            //console.log('Requesting lock', msg);
            if (conn.getPeer() === msg.sender) {
                console.log("Removing peer and connection");
                this.peers.splice(this.peers.indexOf(msg.sender), 1);
                this.connections.splice(this.connections.indexOf(conn), 1);
            }
        }
        this.onConnectionCallback();
    };
    return VcCommunication;
}());
var VC_MESSAGE_TYPE;
(function (VC_MESSAGE_TYPE) {
    VC_MESSAGE_TYPE[VC_MESSAGE_TYPE["NEW_CONNECTION"] = 0] = "NEW_CONNECTION";
    VC_MESSAGE_TYPE[VC_MESSAGE_TYPE["EVENT"] = 1] = "EVENT";
    VC_MESSAGE_TYPE[VC_MESSAGE_TYPE["LOCK_REQUESTED"] = 2] = "LOCK_REQUESTED";
    VC_MESSAGE_TYPE[VC_MESSAGE_TYPE["LOCK_VOTE"] = 3] = "LOCK_VOTE";
    VC_MESSAGE_TYPE[VC_MESSAGE_TYPE["LOCK_OWNER_CHANGED"] = 4] = "LOCK_OWNER_CHANGED";
    VC_MESSAGE_TYPE[VC_MESSAGE_TYPE["DISCONNECTION"] = 5] = "DISCONNECTION";
})(VC_MESSAGE_TYPE || (VC_MESSAGE_TYPE = {}));

var VcProtocol = /** @class */ (function () {
    function VcProtocol(leaderId, ownId, executeEvent, cancelEvent, unsafeElements, MockCommunication) {
        this.leaderId = leaderId;
        this.ownId = ownId;
        this.executeEvent = executeEvent;
        this.cancelEvent = cancelEvent;
        this.unsafeElements = unsafeElements;
        this.ledgers = new Map();
        this.lockOwners = new Map();
        this.requestedLocks = new Set();
        this.heldEvents = new Map();
        this.heldRemoteEvents = new Map();
        this.collaboratorId = '';
        var Communication = MockCommunication ? MockCommunication : VcCommunication;
        this.communication = new Communication({
            leaderId: leaderId,
            ownId: ownId,
            onEventReceived: this.receiveRemoteEvents.bind(this),
            onNewLockOwner: this.lockOwnerChanged.bind(this),
            getPastEvents: this.getPastEvents.bind(this),
            onLockRequested: this.receiveLockRequest.bind(this),
            onOpenCallback: this.init.bind(this)
        });
        this.communication.init();
    }
    VcProtocol.prototype.init = function () {
        this.collaboratorId = this.communication.getId();
    };
    VcProtocol.prototype.getPastEvents = function () {
        var events = Array.from(this.ledgers.values()).reduce(function (a, b) { return a.concat(b); }, []);
        return events.sort(function (a, b) { return a.event.timeStamp - b.event.timeStamp; });
    };
    VcProtocol.prototype.localEvent = function (stripped) {
        var selector = stripped.target;
        stripped.collaboratorId = this.communication.getId();
        //console.log('local event on ', selector, this.lockOwners.get(selector), this.collaboratorId);
        // All clients are allowed to interact with the unsafe elements.
        var allAllowed = this.unsafeElements.includes(stripped.targetType) || this.unsafeElements.includes('*');
        var lockOwner = this.lockOwners.get(selector);
        if (allAllowed || (lockOwner && lockOwner === this.collaboratorId)) {
            var vcEvent = this.makeVcEvent(stripped);
            var success = this.addEventToLedger(vcEvent, this.collaboratorId);
            if (success) {
                this.communication.broadcastEvent(vcEvent);
            }
        }
        else if (lockOwner && lockOwner !== this.collaboratorId) {
            // Do nothing - do not execute the event.
            this.cancelEvent(stripped);
        }
        else {
            if (!this.heldEvents.has(selector)) {
                this.heldEvents.set(selector, []);
            }
            this.heldEvents.get(selector).push(stripped);
            //console.log('held', this.heldEvents.get(selector));
            this.requestLock(selector);
        }
    };
    VcProtocol.prototype.receiveRemoteEvents = function (events, sender, catchup) {
        if (catchup === void 0) { catchup = false; }
        for (var _i = 0, events_1 = events; _i < events_1.length; _i++) {
            var event = events_1[_i];
            var ledger = this.ledgers.get(event.event.target);
            var lastSeqNum = ledger && ledger.length ? ledger[ledger.length - 1].seqNum : -1;
            this.playHeldRemoteEvents(event.event.target, lastSeqNum);
            lastSeqNum = ledger && ledger.length ? ledger[ledger.length - 1].seqNum : -1;
            if (event.seqNum !== lastSeqNum + 1) {
                this.holdRemoteEvent(event);
            }
            else {
                var success = this.addEventToLedger(event, sender, catchup);
                if (!success && !this.lockOwners.has(event.event.target)) {
                    this.holdRemoteEvent(event);
                }
            }
        }
    };
    VcProtocol.prototype.holdRemoteEvent = function (event) {
        if (!this.heldRemoteEvents.has(event.event.target)) {
            this.heldRemoteEvents.set(event.event.target, []);
        }
        this.heldRemoteEvents.get(event.event.target).push(event);
        //console.log('adding event to held remote events on ', this.collaboratorId);
    };
    VcProtocol.prototype.receiveLockRequest = function (selector, requester) {
        console.error('Clients are not supposed to receive lock requests.');
    };
    VcProtocol.prototype.lockOwnerChanged = function (selector, owner, seqNum) {
        //console.log('Lock owner changed', selector, owner, this.collaboratorId, this.heldEvents.has(selector), this.heldEvents.get(selector));
        this.requestedLocks.delete(selector);
        if (!owner) {
            this.lockOwners.delete(selector);
            return;
        }
        this.lockOwners.set(selector, owner);
        if (owner === this.collaboratorId && this.heldEvents.has(selector)) {
            // Finally, trigger these held up events.
            var events = this.heldEvents.get(selector);
            //console.log('Triggering some held up events', events);
            for (var _i = 0, events_2 = events; _i < events_2.length; _i++) {
                var stripped = events_2[_i];
                if (this.canExecuteEvent(stripped, this.collaboratorId)) {
                    var vcEvent = this.makeVcEvent(stripped);
                    var success = this.addEventToLedger(vcEvent, this.collaboratorId);
                    if (success) {
                        this.communication.broadcastEvent(vcEvent);
                    }
                }
            }
            //this.heldEvents.delete(selector);
        }
        else if (this.heldRemoteEvents.has(selector)) {
            this.playHeldRemoteEvents(selector, seqNum);
        }
    };
    VcProtocol.prototype.playHeldRemoteEvents = function (selector, seqNum) {
        var held = this.heldRemoteEvents.get(selector);
        if (!held) {
            return;
        }
        var filtered = held.filter(function (e) { return e.seqNum >= seqNum; }).sort(function (a, b) { return a.seqNum - b.seqNum; });
        for (var _i = 0, filtered_1 = filtered; _i < filtered_1.length; _i++) {
            var event = filtered_1[_i];
            this.addEventToLedger(event, event.sender, false);
        }
        //this.heldRemoteEvents.delete(selector);
    };
    VcProtocol.prototype.requestLock = function (selector) {
        if (this.requestedLocks.has(selector)) {
            return;
        }
        //console.log('Requesting lock on ', selector);
        var success = this.communication.requestLock(selector);
        if (success) {
            this.requestedLocks.add(selector);
        }
    };
    VcProtocol.prototype.canExecuteEvent = function (stripped, sender, catchup) {
        if (catchup === void 0) { catchup = false; }
        var selector = stripped.target;
        var allAllowed = this.unsafeElements.includes(stripped.targetType) || this.unsafeElements.includes('*');
        // Skip ownership check for catchup events, and for background events.
        if (!catchup && !allAllowed) {
            var lockOwner = this.lockOwners.get(selector);
            if (!lockOwner) {
                return false;
            }
            else if (lockOwner !== sender) {
                console.error('Trying to execute event on element with different lock owner', selector, lockOwner, sender);
                return false;
            }
        }
        return true;
    };
    VcProtocol.prototype.makeVcEvent = function (stripped) {
        var ledger = this.ledgers.get(stripped.target);
        var seqNum = 0;
        if (ledger && ledger.length) {
            var lastEvent = ledger[ledger.length - 1];
            seqNum = lastEvent.seqNum + 1;
        }
        return {
            seqNum: seqNum,
            event: stripped,
            sender: this.collaboratorId
        };
    };
    VcProtocol.prototype.addEventToLedger = function (event, sender, catchup) {
        if (catchup === void 0) { catchup = false; }
        var stripped = event.event;
        var selector = stripped.target;
        if (!this.canExecuteEvent(stripped, sender, catchup)) {
            return false;
        }
        if (!this.ledgers.has(selector)) {
            this.ledgers.set(selector, []);
        }
        var ledger = this.ledgers.get(selector);
        var seqNum = 0;
        if (ledger.length) {
            var lastEvent = ledger[ledger.length - 1];
            seqNum = lastEvent.seqNum + 1;
        }
        if (event.seqNum === seqNum) {
            ledger.push(event);
            //console.log(seqNum, stripped.type);
            this.executeEvent(stripped);
            return true;
        }
        else {
            // The order is not right.
            //console.log('cant execute this', event.seqNum);
            return false;
        }
    };
    return VcProtocol;
}());

var LockService = /** @class */ (function () {
    function LockService(communication) {
        this.communication = communication;
        this.lockOwners = new Map();
        this.lockTimeouts = new Map();
        this.expireTimeoutMs = 1000;
    }
    LockService.prototype.requestLock = function (selector, client, seqNum) {
        if (this.lockOwners.has(selector)) {
            return;
        }
        this.lockOwners.set(selector, client);
        this.communication.changeLockOwner(selector, client, seqNum);
    };
    LockService.prototype.extendLock = function (selector) {
        // Delete any previous timeouts
        var prevTimeout = this.lockTimeouts.get(selector);
        if (prevTimeout) {
            clearTimeout(prevTimeout);
        }
        var timeout = setTimeout(this.expireLock(selector), this.expireTimeoutMs);
        this.lockTimeouts.set(selector, timeout);
    };
    LockService.prototype.expireLock = function (selector) {
        var _this = this;
        return function () {
            _this.lockOwners.delete(selector);
            _this.communication.changeLockOwner(selector, '', -1);
        };
    };
    return LockService;
}());

var VcLeaderProtocol = /** @class */ (function (_super) {
    __extends(VcLeaderProtocol, _super);
    function VcLeaderProtocol(leaderId, ownId, executeEvent, cancelEvent, unsafeElements, mockCommunication) {
        var _this = _super.call(this, leaderId, ownId, executeEvent, cancelEvent, unsafeElements, mockCommunication) || this;
        _this.leaderId = leaderId;
        _this.ownId = ownId;
        _this.executeEvent = executeEvent;
        _this.cancelEvent = cancelEvent;
        _this.unsafeElements = unsafeElements;
        _this.lockService = new LockService(_this.communication);
        return _this;
    }
    VcLeaderProtocol.prototype.receiveLockRequest = function (selector, requester) {
        var ledger = this.ledgers.get(selector);
        var seqNum = !ledger ? 0 : ledger[ledger.length - 1].seqNum + 1;
        this.lockService.requestLock(selector, requester, seqNum);
    };
    VcLeaderProtocol.prototype.addEventToLedger = function (event, sender) {
        var success = _super.prototype.addEventToLedger.call(this, event, sender);
        if (success) {
            this.lockService.extendLock(event.event.target);
        }
        return success;
    };
    return VcLeaderProtocol;
}(VcProtocol));

function getMockNetwork(numClients) {
    var leaderComm;
    var communications = [];
    var leader = getMockClient('leader', 'leader');
    leaderComm = leader.communication;
    communications.push(leader.communication);
    var clients = [];
    for (var i = 1; i <= numClients; i++) {
        var client = getMockClient("client" + i, 'leader');
        clients.push(client);
        communications.push(client.communication);
    }
    for (var _i = 0, communications_1 = communications; _i < communications_1.length; _i++) {
        var comm = communications_1[_i];
        comm.communications = communications;
        comm.leaderComm = leaderComm;
    }
    return { leader: leader, clients: clients };
}
function getMockClient(id, leaderId) {
    var execute = function () { };
    var cancel = function () { };
    var isLeader = id === leaderId;
    var Protocol = isLeader ? VcLeaderProtocol : VcProtocol;
    var protocol = new Protocol(leaderId, id, execute, cancel, [], MockCommunication);
    var communication = protocol.communication;
    communication.id = id;
    communication.data.onOpenCallback();
    return protocol;
}
var MockCommunication = /** @class */ (function () {
    function MockCommunication(data) {
        this.data = data;
        this.id = '';
        this.leaderId = '';
        this.communications = [];
        this.delay = false;
        this.onConnectionCallback = function () { };
        this.init = function () { };
    }
    MockCommunication.prototype.getId = function () { return this.id; };
    MockCommunication.prototype.broadcastEvent = function (stripped) {
        var _this = this;
        this.communications.forEach(function (comm) {
            if (comm.id !== _this.id) {
                var receive = function () { return comm.data.onEventReceived([__assign({}, stripped)], _this.id); };
                _this.delay ? setTimeout(receive, _this.delay) : receive();
            }
        });
    };
    MockCommunication.prototype.requestLock = function (selector) {
        var _this = this;
        //console.log(`client ${this.id} requesting lock for ${selector}`);
        if (!this.leaderComm) {
            console.error('no leader comm');
            return false;
        }
        var leader = this.leaderComm;
        var req = function () { return leader.data.onLockRequested(selector, _this.id); };
        this.delay ? setTimeout(req, this.delay) : req();
        return true;
    };
    MockCommunication.prototype.changeLockOwner = function (selector, owner, seqNum) {
        var _this = this;
        //console.log(`client ${this.id} declaring new lock owner ${owner} on element ${selector}`);
        this.communications.forEach(function (comm) {
            var cb = function () { return comm.data.onNewLockOwner(selector, owner, seqNum); };
            _this.delay ? setTimeout(cb, _this.delay) : cb();
        });
    };
    MockCommunication.prototype.getNumberOfConnections = function () {
        return this.communications.length;
    };
    return MockCommunication;
}());

describeWG('Protocol', function () {
    testWG('Events get executed on client and leader when client sends', function () {
        var _a = getMockNetwork(1), leader = _a.leader, client = _a.clients[0];
        client.localEvent(createEvent());
        expectWG(client.ledgers.get('svg').length).toBe(1);
        expectWG(leader.ledgers.get('svg').length).toBe(1);
    });
    testWG('Events get executed on client and leader when leader sends', function () {
        var _a = getMockNetwork(1), leader = _a.leader, client = _a.clients[0];
        leader.localEvent(createEvent());
        expectWG(client.ledgers.get('svg').length).toBe(1);
        expectWG(leader.ledgers.get('svg').length).toBe(1);
    });
    testWG('Multiple events get executed', function () {
        var _a = getMockNetwork(1), leader = _a.leader, client = _a.clients[0];
        client.localEvent(createEvent());
        client.localEvent(createEvent());
        expectWG(client.ledgers.get('svg').length).toBe(2);
        expectWG(leader.ledgers.get('svg').length).toBe(2);
    });
    testWG('Conflicting events get blocked', function () {
        var _a = getMockNetwork(1), leader = _a.leader, client = _a.clients[0];
        leader.localEvent(createEvent());
        expectWG(client.ledgers.get('svg').length).toBe(1);
        expectWG(leader.ledgers.get('svg').length).toBe(1);
        client.localEvent(createEvent());
        expectWG(client.ledgers.get('svg').length).toBe(1);
        expectWG(leader.ledgers.get('svg').length).toBe(1);
    });
    testWG('Delays work as expected', function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a, leader, client;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = getMockNetwork(1), leader = _a.leader, client = _a.clients[0];
                    leader.communication.delay = false;
                    client.communication.delay = 20;
                    client.localEvent(createEvent());
                    expectWG(client.ledgers.get('svg')).toBeFalsy();
                    expectWG(leader.ledgers.get('svg')).toBeFalsy();
                    return [4 /*yield*/, wait(60)];
                case 1:
                    _b.sent();
                    expectWG(client.ledgers.get('svg').length).toBe(1);
                    expectWG(leader.ledgers.get('svg').length).toBe(1);
                    client.localEvent(createEvent());
                    expectWG(client.ledgers.get('svg').length).toBe(2);
                    expectWG(leader.ledgers.get('svg').length).toBe(1);
                    return [4 /*yield*/, wait(30)];
                case 2:
                    _b.sent();
                    expectWG(client.ledgers.get('svg').length).toBe(2);
                    expectWG(leader.ledgers.get('svg').length).toBe(2);
                    return [2 /*return*/];
            }
        });
    }); });
    testWG('Multiple element executors work in succession', function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a, leader, client;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = getMockNetwork(1), leader = _a.leader, client = _a.clients[0];
                    leader.lockService.expireTimeoutMs = 50;
                    leader.localEvent(createEvent());
                    expectWG(client.ledgers.get('svg').length).toBe(1);
                    expectWG(leader.ledgers.get('svg').length).toBe(1);
                    return [4 /*yield*/, wait(60)];
                case 1:
                    _b.sent();
                    client.localEvent(createEvent());
                    expectWG(client.ledgers.get('svg').length).toBe(2);
                    expectWG(leader.ledgers.get('svg').length).toBe(2);
                    return [2 /*return*/];
            }
        });
    }); });
});
var wait = function (ms) { return new Promise(function (resolve) { return setTimeout(resolve, ms); }); };
var createEvent = function () {
    return {
        type: 'mousedown',
        target: 'svg',
        targetType: 'svg',
        timeStamp: 0,
        collaboratorId: '',
        touches: []
    };
};
